/***************************************************************************
 *   Copyright (C) 2006 by George Kiagiadakis   *
 *   gkiagia@users.sourceforge.net   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef WINELAUNCHER_H
#define WINELAUNCHER_H

#include "interactiveprocess.h"
#include <QFile>

class WineLauncher : private InteractiveProcess
{
	Q_OBJECT

public:
	WineLauncher();
	~WineLauncher();

	void startWine(QString winApp, QStringList arguments = QStringList());
	void setCfgName(QString name);
	void setDebug(QString str);
	void setSilent(bool silentOn);
	void setLogFile(QString filename);
	enum qAppQuitType{quit, ask, continueRunning};
	void setQuitMode(qAppQuitType choice);
	void setWorkDir(QString dir);

	static void startTerminal(QString cfgName, QString winApp, QStringList arguments = QStringList(), QString logfile = QString(), QString debugStr = QString(), QString workdir = QString() );

private slots:
	void readStandardOutput();
	void readStandardError();
	void exitCodeHandler( int exitCode, QProcess::ExitStatus exitStatus );

private:
	bool silent;
	bool envIsSet;
	bool logIsOn;
	QFile log;
	QFile out;
	QFile err;
	qAppQuitType qAppQuitAfterExit;
};

#endif
